clear
beep off
clc
addpath('..\functions')
file=1;
irun=1;
if irun==0
    load initialx
    irun=1;
end
REPS=30000;
BURN=10000;
SKIP=10;
Sindex=BURN+1:SKIP:REPS;
npart=20;
dfolder='../data/';
sfolder='./results/';
tic;


fsize=length(Sindex);
L=2; %lags of endogenous variables
LI=1; %AR order for idiosyncratic errors. 1 is hardcoded in current version

nfact=3; %number of factors
EX=1;  %exogenous regressors in transition equations (only constant)

CHECK=1;
maxdraws=1000;
horizon=12;
T0=40;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55555

 sfile=strcat(sfolder,'forecastzzmxx',num2str(file),'.mat');
  sfilep=strcat(sfolder,'progressxx',num2str(file),'.mat');

 dfile=strcat(dfolder,'data2017','.mat');
 

 

load(dfile);
id=unique(index);
id(id==0)=[];
NC=length(id);
NN=cols(dataS);
idc=vec(repmat(1:NC,nfact,1));

idr=unique(indexe);
idr(idr==0)=[];
NR=length(idr);
idrr=vec(repmat(1:NR,nfact,1));


dataS=standardise(packr(dataS)).*10;
%initial estimate of the factors
pmatw=extract(dataS,nfact);
dataSS=dataS-pmatw*(pmatw\dataS);
%regional factors
pmate=zeros(rows(pmatw),nfact*NR);
ii=1;
for i=1:NR
    dataR=dataSS(:,indexe==idr(i));
    tmp=extract(dataR,nfact);
pmate(:,ii:ii+nfact-1)=tmp;

ii=ii+nfact;
end

dataSSS=zeros(rows(pmatw),NN);
for j=1:NN
      
        yy=dataS(:,j);
        xx=[pmatw pmate(:,idrr==indexe(j))];
        BB=xx\yy;
        dataSSS(:,j)=yy-xx*BB;

end

pmatc=zeros(rows(pmatw),nfact*NC);
ii=1;
for i=1:NC
    dataC=dataSSS(:,index==id(i));
    tmp=extract(dataC,nfact);
pmatc(:,ii:ii+nfact-1)=tmp;

ii=ii+nfact;
end

res=zeros(rows(pmatw),NN);
for j=1:NN
      
        yy=dataS(:,j);
        xx=[pmatw pmate(:,idrr==indexe(j)) pmatc(:,idc==index(j))];
        BB=xx\yy;
        res(:,j)=yy-xx*BB;

end



dataw=pmatw;
datac=pmatc;
datae=pmate;


[Yw,Xw]=preparex(dataw,L);



%Minnesota type prior for the VAR coefficients via dummy observations
LAMDAP=0.1;
TAUP=10*LAMDAP;
EPSILON=1/1000;

RW=0;
[ydw,xdw]=getdummies0(LAMDAP,TAUP,EPSILON,Yw,L);


ii=1;
for i=1:NC
[ydc(i,:,:),xdc(i,:,:)]=getdummies0(LAMDAP,TAUP,EPSILON,datac(:,ii:ii+nfact-1),L);
ii=ii+nfact;
end


ii=1;
for i=1:NR
[yde(i,:,:),xde(i,:,:)]=getdummies0(LAMDAP,TAUP,EPSILON,datae(:,ii:ii+nfact-1),L);
ii=ii+nfact;
end









%starting value for the stochastic volatility
yw=Yw(T0+1:end,:);
xw=Xw(T0+1:end,:);


res=res(T0+L+1:end,:);
N=nfact;
T=rows(xw);
if irun
[outhw,outfw,outgw,outAw]=getinitialvolcc(dataw,1500,1000,T0,L);
outhsw=standardise(log(outhw));
[tmp,lam]=extract(outhsw,1);
h0w=exp(tmp);
lamw=h0w\outhw;
Qbigw=mean(outgw);
Sbigw=lamw/lamw(1);
Cw0= chofac(N,outAw(1,:)');
g0w=mean(outgw);

%
h0e=zeros(rows(h0w),NR);
ii=1;
Sbige=zeros(NR,N);
Qbige=zeros(NR,1);
for i=1:NR
[outhe,outfe,outge,outAe]=getinitialvolcc(datae(:,ii:ii+nfact-1),1500,1000,T0,L);
outhse=standardise(log(outhe));
[tmp,lam]=extract(outhse,1);
h0e(:,i)=exp(tmp);
lamc=h0e(:,i)\outhe;
Qbige(i)=mean(outge);
Sbige(i,:)=lamc/lamc(1);
Ce0(i,:,:)=chofac(N,outAe(1,:)');
g0e(i)=mean(outge);
ii=ii+nfact;
end




%


h0c=zeros(rows(h0w),NC);
ii=1;
Sbigc=zeros(NC,N);
Qbigc=zeros(NC,1);
for i=1:NC
[outhc,outfc,outgc,outAc]=getinitialvolcc(datac(:,ii:ii+nfact-1),1500,1000,T0,L);
outhsc=standardise(log(outhc));
[tmp,lam]=extract(outhsc,1);
h0c(:,i)=exp(tmp);
lamc=h0c(:,i)\outhc;
Qbigc(i)=mean(outgc);
Sbigc(i,:)=lamc/lamc(1);
Cc0(i,:,:)=chofac(N,outAc(1,:)');
g0c(i)=mean(outgc);
ii=ii+nfact;
end







[outhx]=getsimplevolx(res);

save initialx 

end
%define priors for variances
vg0=5;             %prior df
p00_a=1000;  %prior variances a1


%define priors for transition
F0=0.95;
S0f=eye(1)*0.1;

%define priors for unconditional mean of transition eq
MUF0=0;
SMUF0=0.1;
meanvolw=zeros(1,1);
mubigw=zeros(1,1);
meanvole=zeros(NR,1);
mubige=zeros(NR,1);
meanvolc=zeros(NC,1);
mubigc=zeros(NC,1);

%define priors for variances
vs0w=5;             %prior df
sx0w=Sbigw.*vs0w;  %prior scale paramter for s[i]~IG(g0,vg0)

vs0e=5;             %prior df
sx0e=Sbige.*vs0w;  %prior scale paramter for s[i]~IG(g0,vg0)

vs0c=5;             %prior df
sx0c=Sbigc.*vs0c;  %prior scale paramter for s[i]~IG(g0,vg0)

%

hlastw=h0w(2:end,:);


%
hlaste=h0e(2:end,:);


%
hlastc=h0c(2:end,:);


mu0w=hlastw(1,:);
mu0e=hlaste(1,:);
mu0c=hlastc(1,:);

mu0w=ones(1,cols(hlastw)).*0.1;
mu0e=ones(rows(mu0e),cols(mu0e)).*0.1;
mu0c=ones(rows(mu0c),cols(mu0c)).*0.1;

%



rese=[];
varcoefe=[];
jj=1;
for i=1:NR
    [ye,xe]=preparex(datae(T0+1:end,jj:jj+nfact-1),L);
    
    tmp=xe\ye;
    rese=[rese ye-xe*tmp];
    varcoefe=[varcoefe;vec(tmp)'];
end



resc=[];
varcoefc=[];
jj=1;
for i=1:NC
    [yc,xc]=preparex(datac(T0+1:end,jj:jj+nfact-1),L);
    
    tmp=xc\yc;
    resc=[resc yc-xc*tmp];
    varcoefc=[varcoefc;vec(tmp)'];
end
varcoef0w=xw\yw;
resw=yw-xw*varcoef0w;  
varcoef0w=vec(varcoef0w)';
varcoef0e=varcoefe;
varcoef0c=varcoefc;


amatw=Cw0;
iamatw=inv(amatw);
amate=Ce0;
iamate=amate;
for i=1:NR
    iamate(i,:,:)=inv(squeeze(amate(i,:,:)));
end
amatc=Cc0;
iamatc=amatc;
for i=1:NC
    iamatc(i,:,:)=inv(squeeze(amatc(i,:,:)));
end

%priors for factor loadings and starting values
FMAT0=[];
for j=0:L-1
    FMAT0=[FMAT0 yw(L-j,:) datae(T0+L-j,:) datac(T0+L-j,:)];
end
P00=eye(cols(FMAT0));
NN=cols(dataS);
elast0=outhx(2:end,:);

FLOAD0=cell(NN,1);

PFLOAD0=cell(NN,1);

Q0=PFLOAD0;

Qin=Q0;
scaling=3.5e-04;

for j=1:NN
      
        yy=dataS(1:T0,j);
        xx=[pmatw(1:T0,:) pmate(1:T0,idrr==indexe(j)) pmatc(1:T0,idc==index(j))];    
        
        BB=xx\yy;
        EE=yy-xx*BB;
        SS=(EE'*EE)/(rows(yy)-cols(xx));
        VV=SS*invpd(xx'*xx);
        
        
        FLOAD0{j}=BB';
        PFLOAD0{j}=VV;
        Q0{j}=VV*scaling*(cols(VV)+1);
        Qin{j}=VV*scaling*(cols(VV)+1);
        

end


DATAS=dataS(T0+L+1:end,:);
pmatw=pmatw(T0+L+1:end,:);
pmate=pmate(T0+L+1:end,:);
pmatc=pmatc(T0+L+1:end,:);







VF0=0.01;
TF0=1;

%priors and starting values for idiosyncratic volatility
MUBAR=ones(1,NN).*0.1;
iSIGMABAR=inv(0.1);
%define priors for transition
F0r=0.8;
S0fr=eye(1)*1;
%define priors for unconditional mean of transition eq
MUF0r=0;
SMUF0r=0.1;
meanvolr=zeros(1,NN);
mubigr=zeros(1,NN);
vr0=5;             %prior df
r0=0.01;  %prior scale paramter for Q[i]~IG(g0,vg0)
Qbigr=ones(1,NN).*r0;

%prior for the persistence of idiosyncratic component
%Minnesota type prior for the VAR coefficients via dummy observations
LAMDAPI=0.1;
TAUPI=0;

[ydI,xdI,BETA0I,SIGMA0I]=getdums(LAMDAPI,TAUPI,LI);

rho=repmat(BETA0I',NN,1);
rho0=rho;





%Gibbs algorithm

pmat0=[pmatw pmate pmatc];
pmat00=pmat0;
% size(pmat0)
% T
xfixw=log(hlastw);
xfixe=log(hlaste);
xfixc=log(hlastc);
xfix0=log(elast0);

%matrices for storage
amatsavew=zeros(fsize,N,N);
amatsavee=zeros(fsize,NR,N,N);
amatsavec=zeros(fsize,NC,N,N);
bsavew=zeros(fsize,1,N*(N*L+EX));
bsavee=zeros(fsize,NR,N*(N*L+EX));
bsavec=zeros(fsize,NC,N*(N*L+EX));
fsave=zeros(fsize,1,NN+(NC+NR+1));
qsave=zeros(fsize,1,NN+(NC+NR+1));
musave=zeros(fsize,1,NN+(NC+NR+1));
hsave=zeros(fsize,T,NN+(NC+NR+1));
Ssave1=zeros(fsize,1,N);
Ssave2=zeros(fsize,NC,N);
Ssave3=zeros(fsize,NR,N);
floadsave=zeros(fsize,NN,T,nfact*3);
Qinsave=zeros(fsize,NN,nfact*3,nfact*3);
pmatsave=zeros(fsize,T,nfact+(nfact*NR)+(nfact*NC));
rhosave=zeros(fsize,NN);
wsave=zeros(fsize,T,NN);
esave=zeros(fsize,T,NN);
csave=zeros(fsize,T,NN);



jgibbs=1;
igibbs=1;
while jgibbs<=fsize
%----------------------------------------------------------------------
 %step1 Sample VAR coefficients World factors
 
  [beta2w,resw,problemw,numtrysw]=...
      getvarcoef(yw,xw,ydw,xdw,...
      Sbigw,iamatw,hlastw(:,1),maxdraws,L,EX);
if problemw
    beta2w=varcoef0w;
else
    varcoef0w=beta2w;
    
end

 %step 2 sample variances 
 [iamatw,amatw]=getamatonlyx(...
     resw,Sbigw,hlastw(1:end,1),Cw0,p00_a,N);
 %Step 3 Sample Sbig
 Sbigoutw=getsbigonlyx(...
     resw,Sbigw,hlastw(1:end,1),vs0w,sx0w,N,amatw);
 Sbigw=Sbigoutw;

 %------------------------------------------------------------------%
  %step 4 Sample coefficients EA factors
 jj=1;
 probleme=0;
 beta2e=zeros(NR,N*(N*L+EX));
 for j=1:NR
     tmp=pmate(:,jj:jj+nfact-1);
     tmp=[tmp(1:L,:);tmp];
     [ye,xe]=preparex(tmp,L);
         
      
     [beta2ej,resej,problemej,numtrysej]=...
      getvarcoef(ye,xe,squeeze(yde(j,:,:)),squeeze(xde(j,:,:)),...
      Sbige(j,:),squeeze(iamate(j,:,:)),hlaste(:,j),maxdraws,L,EX);
   if problemej
    beta2ej=varcoef0e(j,:)';
    else
    varcoef0e(j,:)=beta2ej';
   end
 beta2e(j,:)=beta2ej';
 
 %step 5 sample variances 
 [iamatej,amatej]=getamatonlyx(...
     resej,Sbige(j,:),hlaste(:,j),squeeze(Ce0(j,:,:)),p00_a,N);
 iamate(j,:,:)=iamatej;
 amate(j,:,:)=amatej;
 %Step 6 Sample Sbig
 Sbigoute=getsbigonlyx(...
     resej,Sbige(j,:),hlaste(:,j),vs0e,sx0e(j,:),N,squeeze(amate(j,:,:)));
 Sbige(j,:)=Sbigoute;
 
 probleme=probleme+problemej;
 jj=jj+nfact;
 end
 
 %--------------------------------------------------------------------
 %step 4 Sample coefficients Country factors
 jj=1;
 problemc=0;
 beta2c=zeros(NC,N*(N*L+EX));
 for j=1:NC
     tmp=pmatc(:,jj:jj+nfact-1);
     tmp=[tmp(1:L,:);tmp];
     [yc,xc]=preparex(tmp,L);
         
      
     [beta2cj,rescj,problemcj,numtryscj]=...
      getvarcoef(yc,xc,squeeze(ydc(j,:,:)),squeeze(xdc(j,:,:)),...
      Sbigc(j,:),squeeze(iamatc(j,:,:)),hlastc(:,j),maxdraws,L,EX);
   if problemcj
    beta2cj=varcoef0c(j,:)';
    else
    varcoef0c(j,:)=beta2cj';
   end
 beta2c(j,:)=beta2cj';
 
 %step 5 sample variances 
 [iamatcj,amatcj]=getamatonlyx(...
     rescj,Sbigc(j,:),hlastc(:,j),squeeze(Cc0(j,:,:)),p00_a,N);
 iamatc(j,:,:)=iamatcj;
 amatc(j,:,:)=amatcj;
 %Step 6 Sample Sbig
 Sbigoutc=getsbigonlyx(...
     rescj,Sbigc(j,:),hlastc(:,j),vs0c,sx0c(j,:),N,squeeze(amatc(j,:,:)));
 Sbigc(j,:)=Sbigoutc;
 
 problemc=problemc+problemcj;
 jj=jj+nfact;
 end
 
 %--------------------------------------------------------------------------------
 
%transition equations for stochastic volatility
%step 7:world factor
[ fbigwnew,Qbigw,mubigw,meanvolw ] = gettrans(hlastw,meanvolw,Qbigw,F0,...
    S0f,g0w*vg0,vg0,MUF0,SMUF0 );
fbigw=fbigwnew;


% EA
fbige=zeros(NR,1);
Qbigenew=zeros(NR,1);
for j=1:NR
    [ fbige(j,:),Qbigenew(j),mubige(j),meanvole(j) ] = ...
        gettrans(hlaste(:,j),meanvole(j),Qbige(j),F0,...
    S0f,g0e(j)*vg0,vg0,MUF0,SMUF0 );
end
Qbige=Qbigenew;
%


fbigc=zeros(NC,1);
%step8: country factor
Qbigcnew=zeros(NC,1);
for j=1:NC
    [ fbigc(j,:),Qbigcnew(j),mubigc(j),meanvolc(j) ] = ...
        gettrans(hlastc(:,j),meanvolc(j),Qbigc(j),F0,...
    S0f,g0c(j)*vg0,vg0,MUF0,SMUF0 );
end
Qbigc=Qbigcnew;
%step9: idiosyncratic variances
fbigr=zeros(1,NN);

for j=1:NN
    [ fbigr(j),Qbigr(j),mubigr(j),meanvolr(j) ] = ...
        gettrans(elast0(:,j),meanvolr(j),Qbigr(j),F0r,...
    S0fr,r0,vr0,MUF0,SMUF0 );
end
%-------------------------------------------------------------------------------------
%step 10 stochastic volatility World
[ hlastw,xfixw ] = getsvolfactorPG( xfixw,fbigw,Qbigw,mubigw,beta2w,Sbigw,...
    yw,xw,N,L,EX,(mu0w),iamatw,npart);


%
tmpe=reshape(pmate,[ T nfact NR]);

parfor j=1:NR
    %tmp=pmatc(:,jj:jj+nfact-1);
    tmp=tmpe(:,:,j);
     tmp=[tmp(1:L,:);tmp];
     [ye,xe]=preparex(tmp,L);
     [ hlaste(:,j),xfixe(:,j) ] = ...
         getsvolfactorPG( xfixe(:,j),fbige(j),Qbige(j),mubige(j),beta2e(j,:),Sbige(j,:),...
    ye,xe,N,L,EX,(mu0e(:,j)),squeeze(iamate(j,:,:)),npart);


end


%

%step 12 stochastic volatility country factor
tmpc=reshape(pmatc,[ T nfact NC]);

parfor j=1:NC
    %tmp=pmatc(:,jj:jj+nfact-1);
    tmp=tmpc(:,:,j);
     tmp=[tmp(1:L,:);tmp];
     [yc,xc]=preparex(tmp,L);
     [ hlastc(:,j),xfixc(:,j) ] = ...
         getsvolfactorPG( xfixc(:,j),fbigc(j),Qbigc(j),mubigc(j),beta2c(j,:),Sbigc(j,:),...
    yc,xc,N,L,EX,(mu0c(:,j)),squeeze(iamatc(j,:,:)),npart);


end

%step 13: Stochastic volatility idiosyncratic errors

parfor j=1:NN
    [betax,BB,W]=ptest1(fbigr(j),mubigr(j),sqrt(Qbigr(j)),1/Qbigr(j),xfix0(:,j),res(:,j),npart,log(MUBAR(j)));
    indexx=discretesample(W(:,end),1);
xfix=betax(:,indexx);
elast0(:,j)=exp(xfix);
xfix0(:,j)=xfix;


end

%-------------------------------------------------------------------------------
%factor loadings, rho, Q

[ fload,qout,rhoout,rho0out,problemout,res ] = ...
    getfloadfactggTVPRF( DATAS,pmatw,pmate,pmatc,FLOAD0,PFLOAD0,Q0,Qin,elast0,nfact,NN,...
    index,NC,indexe,rho,BETA0I,SIGMA0I,rho0,LI,NR );
Qin=qout;
rho0=rho0out;
rho=rhoout;

%convert fload to matrix
floadx=zeros(NN,T,nfact*3);
qoutx=zeros(NN,nfact*3,nfact*3);
for j=1:NN
    tmp=fload{j};
    tmp1=qout{j};
    floadx(j,:,1:cols(tmp))=tmp;
    qoutx(j,1:cols(tmp),1:cols(tmp))=tmp1;
end



%--------------------------------------------------------------------------------
%create matrices of the state-space to draw factors

%transition equation
Fx=zeros(((NC+NR+1)*nfact)*L,((NC+NR+1)*nfact)*L);
Mux=zeros(((NC+NR+1)*nfact)*L,T);

%world factor
beta3=reshape(beta2w,N*L+EX,N);
exo3=xw(:,N*L+1:end)*beta3(N*L+1:end,:);
Mux(1:nfact,:)=exo3';
beta4=beta3(1:N*L,:)';
Fxi=zeros(nfact,((NC+NR+1)*nfact)*L);
jjx=1;
kkx=1;
for jx=1:L
    tmp=beta4(:,jjx:jjx+N-1);
    Fxi(:,kkx:kkx+N-1)=tmp;
    jjx=jjx+N;
    kkx=kkx+(nfact*(NC+NR+1));
end 
Fx(1:nfact,:)=Fxi;


%EA Factor

jj=1;
kk=nfact+1;
for j=1:rows(beta2e)
beta3=reshape(beta2e(j,:),N*L+EX,N);
tmp=pmate(:,jj:jj+nfact-1);
     tmp=[tmp(1:L,:);tmp];
     [ye,xe]=preparex(tmp,L);
         
exo3=xe(:,N*L+1:end)*beta3(N*L+1:end,:);
beta4=beta3(1:N*L,:)';

Fxi=zeros(nfact,((NC+NR+1)*nfact)*L);
jjx=1;
kkx=kk;
for jx=1:L
    tmp=beta4(:,jjx:jjx+N-1);
    Fxi(:,kkx:kkx+N-1)=tmp;
    jjx=jjx+N;
    kkx=kkx+(nfact*(NC+NR+1));
end 


Fx(kk:kk+N-1,:)=Fxi;
Mux(kk:kk+N-1,:)=exo3';
kk=kk+N;
jj=jj+nfact;
end

%country factors

jj=1;
kk=nfact+(NR*nfact)+1;
for j=1:rows(beta2c)
beta3=reshape(beta2c(j,:),N*L+EX,N);
tmp=pmatc(:,jj:jj+nfact-1);
     tmp=[tmp(1:L,:);tmp];
     [yc,xc]=preparex(tmp,L);
         
exo3=xc(:,N*L+1:end)*beta3(N*L+1:end,:);
beta4=beta3(1:N*L,:)';

Fxi=zeros(nfact,((NC+NR+1)*nfact)*L);
jjx=1;
kkx=kk;
for jx=1:L
    tmp=beta4(:,jjx:jjx+N-1);
    Fxi(:,kkx:kkx+N-1)=tmp;
    jjx=jjx+N;
    kkx=kkx+(nfact*(NC+NR+1));
end 


Fx(kk:kk+N-1,:)=Fxi;
Mux(kk:kk+N-1,:)=exo3';
kk=kk+N;
jj=jj+nfact;
end
Fx(((NC+NR+1)*nfact)+1:end,1:end)=eye(((NC+NR+1)*nfact)*(L-1),((NC+NR+1)*nfact)*L);




%step 14---------------------draw factor---------------------
DATASP=DATAS-lag0(DATAS,1).*repmat(rho',T,1);
DATASP(1,:)=DATASP(2,:);
[pmat,beta_tt]=...
    getfactorwSVOLtvpR(DATASP,floadx,Fx,Mux,FMAT0,P00,elast0,hlastc, hlastw,hlaste,...
    iamatc,iamatw,iamate,Sbigc,Sbigw,Sbige,...
    NC,nfact,index,rho,L,NR,indexe);
problempmat=0;
if any(isnan(pmat)) 
    problempmat=1;
end
if problempmat
    pmat=pmat0;
else
    pmat0=pmat;
end
[yw,xw]=preparex([pmat(1:L,1:nfact);pmat(:,1:nfact)],L);

pmatc=pmat(:,(nfact*(NR+1))+1:end);
pmate=pmat(:,nfact+1:(nfact*(NR+1)));  
pmatw=pmat(:,1:nfact);  

 save(sfilep,'pmat','pmat00','fload','problemout','hlastw','hlastc','hlaste','fbigw','Qbigw','fbige','Qbige');
disp(sprintf('Iteration Number= %s file no=%s ', num2str([igibbs problemw problemc problemout problempmat]),num2str(file)));


%impulse response to interest rate volatility
if igibbs>BURN
  
            if sum(Sindex==igibbs)>0

       amatsavew(jgibbs,:,:)=iamatw;
       amatsavee(jgibbs,:,:,:)=iamate;
amatsavec(jgibbs,:,:,:)=iamatc;
bsavew(jgibbs,:,:)=beta2w;
bsavee(jgibbs,:,:)=beta2e;
bsavec(jgibbs,:,:)=beta2c;
fsave(jgibbs,:,:)=[fbigw fbige' fbigc' fbigr];
qsave(jgibbs,:,:)=[Qbigw Qbige' Qbigc' Qbigr];
musave(jgibbs,:,:)=[mubigw mubige' mubigc' mubigr];
hsave(jgibbs,:,:)=[hlastw(:,1) hlaste hlastc elast0];
Ssave1(jgibbs,:,:)=Sbigw';
Ssave3(jgibbs,:,:)=Sbige;
Ssave2(jgibbs,:,:)=Sbigc; 
floadsave(jgibbs,:,:,:)=floadx;%=zeros(fsize,NN,nfact);
Qinsave(jgibbs,:,:,:)=qoutx;
rhosave(jgibbs,:)=rho';
pmatsave(jgibbs,:,:)=pmat;%=zeros(fsize,T,nfact); 

%compute variance decomp
volw=zeros(T,nfact);
vole=zeros(T,nfact*NR);
volc=zeros(T,nfact*NC);
totalvol=zeros(T,NN);
totalw=zeros(T,NN);
totale=zeros(T,NN);
totalc=zeros(T,NN);
for t=1:T
    sigmaw=iamatw*diag(hlastw(t,1).*Sbigw)*iamatw';
    tmp=volatility( beta2w,sigmaw,N,L );
    volw(t,:)=diag(tmp);

      %unconditional variance region factor
mmm=1;
for mm=1:NR
    sigmae=squeeze(iamate(mm,:,:))*...
        diag(hlaste(t,mm).*Sbige(mm,:))*squeeze(iamate(mm,:,:))';
    tmp=volatility( beta2e(mm,:),sigmae,N,L );
    vole(t,mmm:mmm+nfact-1)=diag(tmp)';
    mmm=mmm+nfact;
end
    
    %unconditional variance country factor
mmm=1;
for mm=1:NC
    sigmac=squeeze(iamatc(mm,:,:))*...
        diag(hlastc(t,mm).*Sbigc(mm,:))*squeeze(iamatc(mm,:,:))';
    tmp=volatility( beta2c(mm,:),sigmac,N,L );
    volc(t,mmm:mmm+nfact-1)=diag(tmp)';
    mmm=mmm+nfact;
end
H=getHR( squeeze(floadx(:,t,:)),nfact,NN,NC,NR,index,indexe,rho,L );
floadsquared=H(:,1:(NC+NR+1)*nfact).^2;

totalvol(t,:)=[volw(t,:) vole(t,:) volc(t,:)]*floadsquared'+(elast0(t,:))./(1-rho.^2)';
totalw(t,:)=volw(t,:)*floadsquared(:,1:nfact)';
totale(t,:)=vole(t,:)*floadsquared(:,nfact+1:(NR+1)*nfact)';
totalc(t,:)=volc(t,:)*floadsquared(:,((NR+1)*nfact)+1:end)';
end

wsave(jgibbs,:,:)=totalw./totalvol;
esave(jgibbs,:,:)=totale./totalvol;
csave(jgibbs,:,:)=totalc./totalvol;




    jgibbs=jgibbs+1;
            end
    end



igibbs=igibbs+1;
end
toc
% save(sfile,'wsave','esave','csave') 
save(sfile,'-v7.3');

