function [ fload,qout,rhoout,rho0out,problemout,res ] = ...
    getfloadfactggTVPRF_MC( dataS,pmatw,pmate,pmatc,FLOAD0,PFLOAD0,Q0,Qin,rmatin,nfact,NN,...
    index,NC,indexe,rhoin,r0,v0,rho0,LI,NR,T0 )


T=rows(pmatw);
%draw factor loadings
fload=cell(NN,1);
rhoout=zeros(NN,LI);
rho0out=rho0;
qout=cell(NN,1);
problemout=0;
% id=unique(index);
% id=[id(2:end);id(1)];
idx=vec(repmat(1:NC,nfact,1));
idr=vec(repmat(1:NR,nfact,1));
res=zeros(T,NN);



    
parfor j=1:NN
    yy=dataS(:,j);
    xx=[pmatw pmate(:,idr==indexe(j)) pmatc(:,idx==index(j))];
    
    %remove serial correlation
    yys=transformrho(yy,rhoin(j,:));
    xxs=transformrho(xx,rhoin(j,:));
    %remove heteroscedasticity
    yyh=yys./sqrt(rmatin(:,j));
    xxh=xxs./repmat(sqrt(rmatin(:,j)),1,cols(xx));
    
    fload0=FLOAD0{j};
    pfload0=PFLOAD0{j};
       q0=Q0{j};
       q=Qin{j};
       
       %draw TVP factor loading
       [BB,resf]=carterkohn1(fload0,pfload0,...
            ones(T,1),q,yyh,xxh);

      fload{j}=BB;
      %sample q
      resq=diff(BB);
      scale1=resq'*resq+q0;
      %T0=cols(q0)+1;
      q1=iwpq(T+T0,invpd(scale1)); %draw from inverse Wishart
qout{j}=q1;
      %sample rho
      resid=yy-sum(xx.*BB,2);  %heteroscedasticity and serial correlation
     ye=resid;
     xe=zeros(rows(ye),LI);
    
     for i=1:LI
         xe(:,i)=lag0(ye,i);
     end
     yeh=ye./sqrt(rmatin(:,j));
    xeh=xe./repmat(sqrt(rmatin(:,j)),1,cols(xe));
     
     
     yeh=yeh(LI+1:end,:);
     xeh=xeh(LI+1:end,:);
     [bdraw,problem]=getARx(yeh,xeh,r0,v0,1);
     if problem
         rhoout(j,:)=rho0(j,:);
     else
          rhoout(j,:)=bdraw';
          rho0out(j,:)=bdraw';
     end   
      problemout=problemout+problem;
    %%%%%%%%%%%remove serial correlation to save residuals for SVOL step
    yyss=transformrho(yy,rhoout(j,:));
    xxss=transformrho(xx,rhoout(j,:)); 
         
    res(:,j)=yyss-sum(xxss.*BB,2); %residuals have no serial correlation by heteroscedastic (epsilon)
end
 

